VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmEdit 
   AutoRedraw      =   -1  'True
   Caption         =   "Edit Rich Text Buffer"
   ClientHeight    =   6420
   ClientLeft      =   48
   ClientTop       =   432
   ClientWidth     =   8556
   ControlBox      =   0   'False
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   6420
   ScaleWidth      =   8556
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   WindowState     =   2  'Maximized
   Begin VB.CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   372
      Left            =   10680
      TabIndex        =   11
      ToolTipText     =   "Moves to end of buffer"
      Top             =   240
      Width           =   852
   End
   Begin VB.CommandButton cmdBullet 
      Caption         =   "Bullet"
      Height          =   372
      Left            =   480
      TabIndex        =   10
      Top             =   6000
      Width           =   852
   End
   Begin VB.CommandButton cmdBlue 
      Caption         =   "Font B&lue"
      Height          =   372
      Left            =   2400
      TabIndex        =   9
      Top             =   6960
      Width           =   972
   End
   Begin VB.CommandButton cmdBlack 
      Caption         =   "Font Blac&k"
      Height          =   372
      Left            =   2400
      TabIndex        =   8
      Top             =   6000
      Width           =   972
   End
   Begin VB.CommandButton cmdRed 
      Caption         =   "Font &Red"
      Height          =   372
      Left            =   2400
      TabIndex        =   7
      Top             =   6480
      Width           =   972
   End
   Begin VB.CommandButton cmdItalics 
      Caption         =   "&Italics"
      Height          =   372
      Left            =   1440
      TabIndex        =   6
      Top             =   6960
      Width           =   852
   End
   Begin VB.CommandButton cmdUnderline 
      Caption         =   "&Underline"
      Height          =   372
      Left            =   1440
      TabIndex        =   5
      Top             =   6480
      Width           =   852
   End
   Begin VB.CommandButton cmdBold 
      Caption         =   "&Bold"
      Height          =   372
      Left            =   1440
      TabIndex        =   4
      Top             =   6000
      Width           =   852
   End
   Begin VB.CommandButton cmdHome 
      Caption         =   "Home"
      Height          =   372
      Left            =   9720
      TabIndex        =   3
      ToolTipText     =   "Moves to beginning of buffer"
      Top             =   240
      Width           =   852
   End
   Begin VB.CommandButton cmdCloseEdit 
      Caption         =   "Close"
      Height          =   372
      Left            =   10800
      TabIndex        =   2
      ToolTipText     =   "Closes Edit form and returns to Whiteboard Presentation"
      Top             =   6480
      Width           =   852
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   372
      Left            =   10800
      TabIndex        =   1
      ToolTipText     =   "Saves all whiteboard(i) changes to file."
      Top             =   6000
      Width           =   852
   End
   Begin RichTextLib.RichTextBox rtfBuffer 
      Height          =   5172
      Left            =   480
      TabIndex        =   0
      Top             =   720
      Width           =   11172
      _ExtentX        =   19706
      _ExtentY        =   9123
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmEdit.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   7.8
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim lngStart, lngStop As Long
Dim lnglength As Long

Private Sub Form_Load()
   lngStart = 0
End Sub

Private Sub Form_Activate()
'Note length of buffer prior to data changes.
'Used for 'Dirty' flag for Close without Save prompt.
   lnglength = Len(rtfBuffer)
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
'For this to work, the form KeyPreview property must be set to True.
'Allows use of Ctrl-b, ,u, i for bold, underline, italics.
   Dim ShiftDown, CtrlDown As Boolean
   CtrlDown = (Shift And vbCtrlMask) > 0
   If KeyCode = vbKeyB And CtrlDown Then Call cmdBold_Click
   If KeyCode = vbKeyU And CtrlDown Then Call cmdUnderline_Click
   If KeyCode = vbKeyI And CtrlDown Then
      KeyCode = 0    'Throw away the real Ctrl-I (tab).  Causes problems.
      Call cmdItalics_Click
   End If
End Sub

Private Sub cmdBlack_Click()
   Call SelectWord
   rtfBuffer.SelColor = vbBlack
   rtfBuffer.SetFocus

End Sub

Private Sub cmdBlue_Click()
   Call SelectWord
   rtfBuffer.SelColor = vbBlue
   rtfBuffer.SetFocus
End Sub

Private Sub cmdRed_Click()
   Call SelectWord
   rtfBuffer.SelColor = vbRed
   rtfBuffer.SetFocus
End Sub

Private Sub cmdBold_Click()
   Call SelectWord
   rtfBuffer.SelBold = Not rtfBuffer.SelBold
   rtfBuffer.SetFocus
End Sub

Private Sub cmdUnderline_Click()
   Call SelectWord
   rtfBuffer.SelUnderline = Not rtfBuffer.SelUnderline
   rtfBuffer.SetFocus
End Sub

Private Sub cmdItalics_Click()
   Call SelectWord
   rtfBuffer.SelItalic = Not rtfBuffer.SelItalic
   rtfBuffer.SetFocus
End Sub

Private Sub cmdBullet_Click()
   rtfBuffer.SelBullet = Not rtfBuffer.SelBullet
   rtfBuffer.SetFocus
End Sub

Private Sub cmdHome_Click()
     rtfBuffer.SetFocus
     SendKeys ("^{Home}")
End Sub
Private Sub cmdEnd_Click()
     rtfBuffer.SetFocus
     SendKeys ("^{End}")
End Sub

Private Sub cmdCloseEdit_Click()
'Hides this form and returns to Main form.
'Re-reads revised tutorial file back into buffer.
'Re-writes the whiteboards with the revised text.
   Dim Dirty As Boolean
   Dim intSaveRequested As Integer
   
   Dirty = Len(rtfBuffer) <> lnglength
   
   If Dirty Then
      intSaveRequested = MsgBox("Data has changed.  Do you wish to " & _
      "save the buffer to file?", vbYesNo + vbQuestion + vbDefaultButton2, _
      "Save Changed Data Query")
      
      If intSaveRequested = vbYes Then
         Call cmdSave_Click
      End If
   
   End If
   
   Me.Hide
   frmMain.Show

End Sub

Private Sub cmdSave_Click()
'Saves revised rtfBuffer back into rich text tutorial file.
   rtfBuffer.SaveFile strFilename, rtfRTF
   Call ReadFileToBuffer(strFilename)
   Call FillWhiteBoards
   MsgBox ("Buffer has been written to file: " & strFilename)
   lnglength = Len(rtfBuffer)    'Clear the Dirty flag.
End Sub

Private Sub SelectWord()
'This procedure selects the entire word if an edit function is called
'with the cursor in the middle of a word with nothing selected.
     Dim intWordStart, intWordStop As Integer
     On Error GoTo 0     'Prevents crashes if selection boundaries are unexpected.
     If rtfBuffer.SelLength > 0 Then Exit Sub 'Something is selected already.
     
     rtfBuffer.Span " ,;:.?!", False, True   'Search to start of word
     intWordStart = rtfBuffer.SelStart
     
     rtfBuffer.Span " ,;:.?!", True, True    'Search to start of word
     intWordStop = rtfBuffer.SelStart + rtfBuffer.SelLength
     
     rtfBuffer.SelStart = intWordStart
     rtfBuffer.SelLength = intWordStop - intWordStart
     
End Sub
